package cs108;

import static java.nio.charset.StandardCharsets.UTF_8;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Map;
import java.util.TreeMap;

public final class WordLengthHist {

    public static void main(String[] args) throws IOException {
        Collection<String> frWords = new ArrayList<>();
        loadWords("mots.txt", frWords);

        Map<Integer, Integer> h = new TreeMap<>();
        for (String w: frWords) {
            int l = w.length();
            if (! h.containsKey(l))
                h.put(l, 1);
            else
                h.put(l, h.get(l) + 1);
        }

        for (Map.Entry<Integer, Integer> e: h.entrySet()) {
            System.out.printf("%2d: %5d%n", e.getKey(), e.getValue());
        }
    }

    private static void loadWords(String fileName, Collection<String> target) throws IOException {
        try (BufferedReader r =
                new BufferedReader(
                        new InputStreamReader(
                                new FileInputStream(fileName), UTF_8))) {
            String w;
            while ((w = r.readLine()) != null)
                target.add(w);
        }
    }
}
